/**********
Copyright 1990 Regents of the University of California.  All rights reserved.
Author: 1985 Thomas L. Quarles
**********/
/*
 */

/* loop through all the devices and 
 * allocate parameter #s to design parameters 
 */

#include "spice.h"
#include <stdio.h>
#include "smpdefs.h"
#include "cktdefs.h"
#include "opampdefs.h"
#include "util.h"
#include "sperror.h"
#include "suffix.h"


int
OPAMPsSetup(info,inModel)
    register SENstruct *info;
    GENmodel *inModel;
{
    register OPAMPmodel *model = (OPAMPmodel *)inModel;
    register OPAMPinstance *here;

    /*  loop through all the voltage source models */
    for( ; model != NULL; model = model->OPAMPnextModel ) {

        /* loop through all the instances of the model */
        for (here = model->OPAMPinstances; here != NULL ;
                here=here->OPAMPnextInstance) {

            if(here->OPAMPsenParmNo){
                here->OPAMPsenParmNo = ++(info->SENparms);
            }

        }
    }
    return(OK);
}

