/**********
Copyright 1990 Regents of the University of California.  All rights reserved.
Author: 1985 Thomas L. Quarles
**********/
/*
 */

#include "spice.h"
#include <stdio.h>
#include "cktdefs.h"
#include "complex.h"
#include "sperror.h"
#include "opampdefs.h"
#include "suffix.h"


/*ARGSUSED*/
int
OPAMPpzLoad(inModel,ckt,s)
    GENmodel *inModel;
    CKTcircuit *ckt;
    SPcomplex *s;
        /* actually load the current voltage value into the 
         * sparse matrix previously provided 
         */
{
    register OPAMPmodel *model = (OPAMPmodel *)inModel;
    register OPAMPinstance *here;

    /*  loop through all the voltage source models */
    for( ; model != NULL; model = model->OPAMPnextModel ) {

        /* loop through all the instances of the model */
        for (here = model->OPAMPinstances; here != NULL ;
                here=here->OPAMPnextInstance) {
            
            *(here->OPAMPposIbrptr) += 1.0 ;
            *(here->OPAMPnegIbrptr) -= 1.0 ;
            *(here->OPAMPibrPosptr) += 1.0 ;
            *(here->OPAMPibrNegptr) -= 1.0 ;
            *(here->OPAMPibrContPosptr) -= here->OPAMPcoeff ;
            *(here->OPAMPibrContNegptr) += here->OPAMPcoeff ;
        }
    }
    return(OK);
}
