/****************************************************************
File generated by Device Model Compiler: BMAC
Author: Bo Wan, 2003
Copyright 2003(c) Mixed-Signal CAD lab. University of Washington.
All rights reserved.
****************************************************************/

#include "spice.h"
#include <stdio.h>
#include "util.h"
#include "cktdefs.h"

// Needed #includes
#include "temp_gen1.gh"

#include "sperror.h"
#include "suffix.h"


/*****************************************************
* Perform the temperature update to the device
* Calculate the conductance as a function of the
* given nominal and current temperatures - the
* device given in the struct is the nominal
* temperature device
*****************************************************/
int RADMOStemp(inModel,ckt)
	GENmodel *inModel;
	register CKTcircuit *ckt;
{
	register RADMOSmodel *model =  (RADMOSmodel *)inModel;
	register RADMOSinstance *here;


	/*  loop through all the Device models */
	for( ; model != NULL; model = model->RADMOSnextModel )
	{
		/* Default Value Processing for Device Models */

// initialize / modify model parameters (function of temperature)
#include "temp_gen2.gc"

		/* loop through all the instances of the model */
		for (here = model->RADMOSinstances; here != NULL ;
			here=here->RADMOSnextInstance)
		{
            
			/* Default Value Processing for Device Instance */

// initialize / modify instance parameters (function of temperature)
#include "temp_gen3.gc"

		}
	}

	return(OK);
}

