/****************************************************************
File generated by Device Model Compiler: BMAC
Author: Bo Wan, 2003
Copyright 2003(c) Mixed-Signal CAD lab. University of Washington.
All rights reserved.
****************************************************************/

//
// Name: uniform bilinear interpolation
// fast interpolation using biliner
// assume x, y are uniformly seperated
//
#include "math.h"
// call method: w = uniform_interpolate_bilinear(&x,&y,&z,6,5,u,v)
double uniform_interpolate_bilinear(double** x, double** y, double*** z,
	int n, int m,
	double u, double v) 
{ 
	int ip,iq;

    double y1,y2,y3,y4;
    double tt,tu;
	int ipInc,iqInc;

    if (u>(*x)[n-1]) {
		#ifdef WBPRINT
		printf("ERROR: out of range! u:%-.15g > x[n-1]:%-.15g\n", u, (*x)[n-1]);
		#endif
		u=(*x)[n-1];
	}
    if (u<(*x)[0]) {
		#ifdef WBPRINT
		printf("ERROR: out of range! u:%-.15g < x[0]:%-.15g\n", u, (*x)[0]);
		#endif
		u=(*x)[0];
	}
    if (v>(*y)[m-1]) {
		#ifdef WBPRINT
		printf("ERROR: out of range! v:%-.15g > y[m-1]:%-.15g\n", v, (*y)[m-1]);
		#endif
		v=(*y)[m-1];
	}
    if (v<(*y)[0]) {
		#ifdef WBPRINT
		printf("ERROR: out of range! v:%-.15g < y[0]:%-.15g\n", v, (*y)[0]);
		#endif
		v=(*y)[0];
	}

	ip = (int) ( (u-(*x)[0])/(((*x)[n-1]-(*x)[0])/(n-1)) );
	iq = (int) ( (v-(*y)[0])/(((*y)[m-1]-(*y)[0])/(m-1)) );

    y1 = (*z)[ip][iq];
    ipInc = (ip+1>=n) ? ip : ip+1;
    iqInc = (iq+1>=m) ? iq : iq+1;
    y2 = (*z)[ipInc][iq];
    y3 = (*z)[ipInc][iqInc];
    y4 = (*z)[ip][iqInc];

	if (ipInc == ip) tt=0;
    else tt = (u-(*x)[ip])/((*x)[ipInc]-(*x)[ip]);
	if (iqInc == iq) tu=0;
    else tu = (v-(*y)[iq])/((*y)[iqInc]-(*y)[iq]);

    return ( (1-tt)*(1-tu)*y1 + tt*(1-tu)*y2 + tt*tu*y3 + (1-tt)*tu*y4 );
  }
 
